module.exports = {
  env: { browser: false, es6: true },
  parser: "@typescript-eslint/parser",
  parserOptions: { ecmaVersion: 2018, sourceType: "module" },
  plugins: ["@typescript-eslint"],
  rules: {
      "@typescript-eslint/explicit-function-return-type": "warn",
      "@typescript-eslint/no-explicit-any": "off",
      "@typescript-eslint/no-unused-vars": ["error", { argsIgnorePattern: "^_", varsIgnorePattern: "^_" }],
      "@typescript-eslint/no-use-before-define": "error",
      "comma-dangle": ["error", "never"],
      curly: "error",
      "eol-last": "warn",
      eqeqeq: ["error", "allow-null"],
      "no-eval": "error",
      "no-import-assign": "error",
      "no-mixed-spaces-and-tabs": "error",
      "no-multi-spaces": "warn",
      "no-return-assign": "error",
      "no-return-await": "error",
      "no-shadow": "error",
      "no-trailing-spaces": "error",
      "no-unused-vars": "off",
      "no-useless-constructor": "error",
      "no-var": "error",
      "prefer-const": "error",
      quotes: ["error", "double", { allowTemplateLiterals: true }],
      semi: ["error", "always"],
      "spaced-comment": "warn"
  }
};
