# CUOR-ORDER-CHAINING-CONSUMER
[![Config Repo cuor-order-chaining-consumer-config](https://shields.haulynx.io/badge/config_repo-cuor--order--chaining--consumer--config-53812c?style=for-the-badge&logo=codecademy)](https://github.com/xpress-technologies/cuor-order-chaining-consumer-config)

`cuor-order-chaining-consumer` is a Kafka consumer accountable for consuming new orders coming through the order stream as described in the Order Bridge domain model and creating new orders related to the source order according to the rules defined in the postgres tables `LaneRule` and `LoadCreationAction`.

## Setting up for local development
- Kafka & Postgres DB
  - Kafka and Postgres instances defined in docker-compose.yml can be containerized and run by invoking `docker-compose up -d`
- Data Migration
  - Migrations utilize TypeORM's Query Runner API. For data migrations, developer is strongly encouraged to use the TypeORM's migration feature to manage and track the updates to the database schemas.
  
## Environment variables for local run

```
# app values
DEPLOYMENT_ENVIRONMENT=local

# logger
LOGGER_LEVEL=error

# kafka
KAFKA_BOOTSTRAP_SERVERS=localhost:9092
KAFKA_USERNAME=admin
KAFKA_PASSWORD=password
KAFKA_SASL_MECHANISM=plain
KAFKA_SOURCE_TOPIC_NAME=bus_iohaulynx_usxorder_event_json


# postgres
POSTGRES_HOST=localhost
POSTGRES_DATABASE=hlnx-rds-cuor-ue1-local
POSTGRES_USERNAME=postgres
POSTGRES_PASSWORD=haulynx-postgres

# USX
USX_API_PASSWORD=
USX_API_URL=
USX_API_USERNAME=
USX_BROKER_ID=

# Auth
AUTH_CLIENT_ID=
AUTH_CLIENT_SECRET=
AUTH_URL=
