import { Kafka } from "kafkajs";
import { testEvent } from "./data/testEvent";

const KafkaTopic = "local_bus_iohaulynx_usxorder_event_json";

const sendLoadEvent = async () => {
  console.log("Starting kafka");
  const kafkaOptions = {
    clientId: "local_bus_iohaulynx_usxorder_event_json",
    brokers: ["127.0.0.1:9092"]
  };

  const kafka = new Kafka(kafkaOptions);

  const producer = kafka.producer();

  console.log("Connecting producer");
  await producer.connect();
  console.log(testEvent);
  // Gather messages to send
  const messages = [testEvent].map(({ key, value }) => {
    return {
      key,
      value: JSON.stringify(value)
    };
  });
  const event = {
    topic: KafkaTopic,
    messages
  };
  console.log(event);

  try {
    const response = await producer.send(event);

    console.log(response);
  } catch (e) {
    console.error(e);
  }

  console.log("Disconnecting producer");
  await producer.disconnect();
};

sendLoadEvent();
