import { KafkaService } from "./services/kafka";
import { APP_NAME, KAFKA_SOURCE_TOPIC } from "./conifg";
import { logger } from "./services/logger";
import { processOrderChainingEvent } from "./consumer/processOrderChainingEvent";

async function runOrderChainingConsumer(): Promise<void> {
  const kafka = new KafkaService();
  const consumer = kafka.getConsumer();
  await consumer.connect();
  await consumer.subscribe({ topic: KAFKA_SOURCE_TOPIC });

  await consumer.run({
      eachMessage: processOrderChainingEvent()
  });
}

export const app = (): void => {
  logger.trace({
    location: APP_NAME,
    message: `Starting ${APP_NAME}`
  });
  runOrderChainingConsumer();
};
