import { Kafka, Consumer, KafkaConfig } from "kafkajs";
import { APP_NAME, KAFKA_BOOTSTRAP_SERVERS, KAFKA_GROUP_ID, KAFKA_PASSWORD, KAFKA_SASL_MECHANISM, KAFKA_USERNAME, DEPLOYMENT_ENVIRONMENT } from "../conifg";

export class KafkaService {
    consumer: Consumer
    client: Kafka
    isConnected = false

    constructor() {
        const kafkaOptions: KafkaConfig = {
            clientId: KAFKA_GROUP_ID,
            brokers: KAFKA_BOOTSTRAP_SERVERS,
            requestTimeout: 20000,
            connectionTimeout: 28000,
            retry: { initialRetryTime: 500 }
          };
          if (DEPLOYMENT_ENVIRONMENT !== "local") {
            kafkaOptions.ssl = true;
            kafkaOptions.sasl = {
              mechanism: KAFKA_SASL_MECHANISM,
              username: KAFKA_USERNAME,
              password: KAFKA_PASSWORD
            };
          }
        this.client = new Kafka(kafkaOptions);
        this.consumer = this.client.consumer({ groupId: `${APP_NAME}-${DEPLOYMENT_ENVIRONMENT}` });
    }

    getConsumer(): Consumer {
        return this.consumer;
    }
}
